----------------------------------- 
-- Bookbiz database creating script  
-----------------------------------

-- 1. Drop old tables in required order

DROP TABLE RoySched;
DROP TABLE TitleAuthors;
DROP TABLE TitlEditors;
DROP TABLE TitlSalesDet;
DROP TABLE TitlSales;
DROP TABLE Editors;
DROP TABLE Publishers;
DROP TABLE Authors;
DROP TABLE Titles;

-- 2. Create tables

----------------------
--    --
----------------------
CREATE TABLE Titles
( 
	Title_Id CHAR( 6 ) PRIMARY KEY,         		--  
	Title VARCHAR2( 80 ) NOT NULL,          		--  
	TType CHAR( 12 ),                       		--  
	Pub_Id CHAR( 4 ),                       		--    
	Price NUMBER( 6, 2 ),                   		-- 
	Advance NUMBER,						-- ( (                           
	Ytd_Sales NUMBER(7),					--   
	Contract NUMBER( 1 )					--    
                 CHECK( Contract IN( 0,1 ) ) 
                 NOT NULL,
	Notes VARCHAR2( 200 ),                  		-- 
	Pubdate DATE                            		--   
);


-----------------------
--    --
-----------------------
CREATE TABLE Authors
( 
	Au_Id CHAR( 11 ) PRIMARY KEY,				--  
	Au_LName VARCHAR2( 40 ) NOT NULL,			--    
	Au_FName VARCHAR2( 20 ),				--    
	Phone CHAR( 12 ) NOT NULL,				-- '   
	Address VARCHAR2( 40 ),					--  
	City VARCHAR2( 20 ),					--  
	State CHAR( 2 ),					--  
	Zip CHAR( 5 )						-- Zip code
);

-----------------------------
--     --
-----------------------------
CREATE TABLE Publishers
( 
	Pub_Id CHAR( 4 ) PRIMARY KEY,				--    
	Pub_name VARCHAR2( 40 ),				--   
	Address VARCHAR2( 40 ),					--   
	City VARCHAR2( 20 ),					--  
	State CHAR( 2 )						--  
);

-----------------------------
--    --
-----------------------------
CREATE TABLE Editors
( 
	Ed_Id CHAR( 11 ) PRIMARY KEY,				--  
	Ed_LName VARCHAR2( 40 ) NOT NULL,			--    
	Ed_FName VARCHAR2( 20 ) NOT NULL,			--    
	Ed_Pos VARCHAR2( 12 ),					-- '   
	Phone CHAR( 12 ),					-- '   
	Address VARCHAR2( 40 ),					--   
	City VARCHAR2( 20 ),					--  
	State CHAR( 2 ),					--  	
	Zip CHAR( 5 )						-- Zip code
);

-----------------------------
--    --
-----------------------------
CREATE TABLE RoySched
( 
	Title_id CHAR( 6 ) NOT NULL 
                           REFERENCES Titles( Title_Id ),	--  
	LoRange NUMBER( 6 ),					-- (   ( 
	HiRange NUMBER( 6 ),					-- (   ( 
	Royalty NUMBER( 3, 2 )					-- (0,1)    
);

-----------------------------------
--          - --
--  -     --
-----------------------------------
CREATE TABLE TitleAuthors
( 
	Au_Id CHAR( 11 ) NOT NULL 
                         REFERENCES Authors( Au_Id ),		--  
	Title_Id CHAR( 6 ) NOT NULL 
                           REFERENCES Titles( Title_Id ),	--  
	Au_Ord NUMBER( 2 ),					--        
	RoyaltyShare NUMBER( 3, 2 ),				-- (0,1]     
	PRIMARY KEY ( Au_Id, Title_Id )
);

-----------------------------------
--          - --
--  -     --
-----------------------------------
CREATE TABLE TitlEditors
( 
	Ed_Id CHAR( 11 ) NOT NULL 
                         REFERENCES Editors( Ed_Id ),		--  
	Title_id CHAR( 6 ) NOT NULL 
                           REFERENCES Titles( Title_Id ),	--  
	Ed_Ord NUMBER(1)					--        
);

------------------
--   --
------------------
CREATE TABLE TitlSales
( 
	SoNum NUMBER( 6 ) PRIMARY KEY,				--  
	Stor_Id CHAR( 4 ) NOT NULL,				--  
	PoNum VARCHAR2( 20 ) NOT NULL,
	SDate DATE						--  
);

-----------------------
--    --
-----------------------
CREATE TABLE TitlSalesDet
( 
	SoNum NUMBER( 6 ) NOT NULL 
                          REFERENCES TitlSales( SoNum ),	--  
	Title_Id CHAR( 6 ) NOT NULL 
                           REFERENCES Titles( Title_Id ),	--  
	Qty_Ordered NUMBER( 3 ) NOT NULL,			--  
	Qty_Shipped NUMBER( 3 ) NULL,				--  
	Date_Shipped DATE					--  
);
