DROP TABLE Checks;
DROP TABLE Account;

CREATE TABLE Account
(
	Bank_Code	NUMBER(2) NOT NULL,
	Branch_Code	NUMBER(3) NOT NULL,
	Account_No	VARCHAR2(12) NOT NULL,
	Owner_Name	VARCHAR2(40),
	Status		NUMBER(2) DEFAULT 0 CHECK( Status IN ( 0,1,2,3 ) ),
	Note		VARCHAR2(60),
	PRIMARY KEY( Bank_Code, Branch_Code, Account_No )
);

CREATE TABLE Checks
(
	Receipt_No	VARCHAR2(6) NOT NULL,
	Ordinal		NUMBER(3) NOT NULL,
	Amount		NUMBER(9,2) CHECK( Amount > 0 ),
	Val_Date	DATE,
	Check_Num	VARCHAR2(8),
	Bank_Code	NUMBER(2) NOT NULL,
	Branch_Code	NUMBER(3) NOT NULL,
	Account_No	VARCHAR2(12) NOT NULL,
	PRIMARY KEY ( Receipt_No, Ordinal ),
	FOREIGN KEY ( Bank_Code, Branch_Code, Account_No ) REFERENCES Account( Bank_Code, Branch_Code, Account_No ) 
);