------------------------------------
-- SQL file for slides no. 31, 33 --
------------------------------------

-- Drop old version of tables --
DROP TABLE Deal;
DROP TABLE Emp1;

-- Create employee table of the same structure as Emp --
CREATE TABLE Emp1
(
	EmpNo		NUMBER(4) NOT NULL PRIMARY KEY,
	EName    	VARCHAR2(10),
	Job         	VARCHAR2(9),
	Mgr       	NUMBER(4),
	HireDate     	DATE,
	Sal          	NUMBER(7,2),
	Comm          	NUMBER(7,2),
	DeptNo        	NUMBER(2) NOT NULL REFERENCES Dept(DeptNo)
);

-- Copy data from Emp to Emp1 --
INSERT INTO Emp1 SELECT * FROM Emp;

-- Create Deal table with foreign key that refernces to Emp1.EmpNo --
CREATE TABLE Deal
 (
  	DealNo 		NUMBER(6) PRIMARY KEY,
  	Deal_Name	VARCHAR2(30) NOT NULL,
  	Essentiality	VARCHAR2(70),
  	Val_Date 	DATE DEFAULT SYSDATE,
  	Amount 		NUMBER(9,2) CHECK( Amount > 0 ),
  	Operator 	NUMBER(4) REFERENCES Emp1( EmpNo ) ON DELETE CASCADE
);

INSERT INTO Deal
VALUES( 1, 'Oracle 8i Online Help', 'Oracle 8i Online Help is sold to DBM Systems Inc', 
	TO_DATE( '15/03/2002', 'DD/MM/YYYY' ), 1200.00, 7499 );
INSERT INTO Deal
VALUES( 2, 'Oracle 8.1.6 ODBC drivers', 'Oracle 8.1.6 ODBC drivers is sold to DBM Systems Inc', 
	'21-MAR-02', 3400.00, 7844 );
INSERT INTO Deal
VALUES( 3, 'Oracle 8 Pro*C/C++', 'Oracle 8 Pro*C/C++ is bought by Dr. Khukhlovich L.', 
	TO_DATE( '02/03/2002', 'DD/MM/YYYY' ), 1980.00, 7521 );
INSERT INTO Deal
VALUES( 4, 'Oracle 7 to 8 migration', 'Oracle 7 to 8 migration software is sold to Teva Ltd', 
	TO_DATE( '17/01/2002', 'DD/MM/YYYY' ), 4440.00, 7844 );
INSERT INTO Deal
VALUES( 5, 'Oracle 8i handbook', '20 copies of Oracle 8i handbook are sold to Tel-Aviv public library', 
	TO_DATE( '05/01/2002', 'DD/MM/YYYY' ), 8129.00, 7654 );
INSERT INTO Deal
      ( DealNo, Deal_Name, Operator )
VALUES( 6, 'Oracle 8.1.6 Personal', 7499 );


--UPDATE Deal
--SET Essentiality = 'Oracle 8.1.6 Personal is bought by Engeneering College',
--    Amount = 2200.00
--WHERE DealNo = 6;

--INSERT INTO Deal ( DealNo, Deal_Name, Operator )
--VALUES( ( SELECT NVL(MAX(DealNo),0)+1 FROM Deal ), 'New deal', 7839 )

COMMIT;
