CREATE OR REPLACE
FUNCTION Rathio( p_e IN NUMBER, p_m IN NUMBER )
  RETURN NUMBER
IS
v_emp NUMBER;
v_mgr NUMBER;
BEGIN
  SELECT sal 
  INTO v_emp 
  FROM emp 
  WHERE empno = p_e;
  IF p_m IS NULL THEN
    RETURN 1;
  END IF;
  SELECT sal 
  INTO v_mgr 
  FROM emp 
  WHERE empno = p_m;
  RETURN v_mgr/v_emp;
END;
/

set linesize 132
set pagesize 2000

COL rat FORMAT '0.999'
SELECT e.empno, e.ename, e.mgr, z.ename, Rathio( e.empno, e.mgr ) AS rat 
FROM emp e, emp z
WHERE e.mgr = z.empno(+)
ORDER BY rat DESC
/
