CONNECT system/manager

DROP TABLE secret1;

CREATE TABLE secret1
(
   vdate DATE,
   empno NUMBER(4),
   old_sal NUMBER(7,2),
   new_sal NUMBER(8,2),
   user_id NUMBER(5)
);

GRANT INSERT ON secret1 TO scott;

CONNECT scott/tiger

CREATE OR REPLACE TRIGGER sal_secret1
AFTER UPDATE OF sal
ON emp
FOR EACH ROW
WHEN ( NEW.sal / OLD.sal > 1.1 )
BEGIN
   INSERT INTO system.secret1
   VALUES( SYSDATE, :OLD.empno, :OLD.sal, :NEW.sal, UID );
END; 
/

UPDATE emp
SET sal = sal + 200;

COMMIT;

CONNECT system/manager

SELECT * FROM secret1;


   