drop view titleview;
create view titleview
as
select title, au_ord, au_lname,
price, ytd_sales, pub_id
from authors, titles, titleauthors
where authors.au_id = titleauthors.au_id
and titles.title_id = titleauthors.title_id;

drop view oaklanders;
create view oaklanders
as
select au_fname, au_lname, title
from authors, titles, titleauthors
where authors.au_id = titleauthors.au_id
  	and titles.title_id = titleauthors.title_id
	and city = 'Oakland';

drop view books;
create view books
as
select titles.title_id, au_ord, au_lname, au_fname
from authors, titles, titleauthors
where authors.au_id=titleauthors.au_id and
     titles.title_id = titleauthors.title_id;

drop view royaltychecks;
create view royaltychecks
as
select au_lname, au_fname,
	sum(price*ytd_sales*royalty*royaltyshare) as Total_Income
from authors, titles, titleauthors, roysched
where authors.au_id=titleauthors.au_id
  and titles.title_id = titleauthors.title_id
  and titles.title_id = roysched.title_id
  and ytd_sales between lorange and hirange
group by au_lname, au_fname;

drop view currentinfo;
create view currentinfo (PUB#, TYPE, INCOME, 
	AVG_PRICE, AVG_SALES)
as
select pub_id, type, sum(price * ytd_sales),
  avg(price), avg(ytd_sales)
from titles
group by pub_id, type;

drop view hiprice;
create view hiprice
as
select *
from titles
where price > 15
  and advance > 5000;

drop view cities;
create view cities (Author, Authorcity, Pub, Pubcity)
as
select au_lname, authors.city, pub_name, publishers.city
from authors, publishers
where authors.city = publishers.city;

drop view highaverage;
create view highaverage
as
select authors.au_id, titles.title_id, pub_name, price
from authors, titleauthors, titles, publishers
where authors.au_id = titleauthors.au_id and
     titles.title_id = titleauthors.title_id and
     titles.pub_id = publishers.pub_id and
     price >
          (select avg(price)
          from titles);

drop view highBandH;
create view highBandH
as select *
from highaverage
where pub_name = 'Binnet and Hardley';

drop view number1;
create view number1
as select au_lname, phone
from authors
where zip like '94%';

drop view number2;
create view number2
as select au_lname, phone
from number1
where au_lname like '[M-Z]%';

drop view number3;
create view number3
as select au_lname, phone
from number2
where au_lname = 'MacFeather';

drop view categories;
create view categories (Category, Average_Price)
as select type, avg(price)
from titles
group by type;

drop view accounts; 
create view accounts (title, advance, gross_sales)
as
select title_id, advance, price * ytd_sales
from titles
where price > 15
  and advance > 5000;
