CREATE OR REPLACE VIEW RoyaltyChecks
AS
SELECT A.Au_LName || ' ' || A.Au_FName AS Author,
       SUM( T.Price * T.Ytd_Sales * R.Royalty * TA.RoyaltyShare ) AS Total_Income
FROM Authors A, Titles T, TitleAuthors TA, RoySched R
WHERE A.Au_Id = TA.Au_Id
  AND T.Title_Id = TA.Title_Id
  AND T.Title_Id = R.Title_Id
  AND T.Ytd_Sales BETWEEN R.LoRange AND R.HiRange
GROUP BY A.Au_LName || ' ' || A.Au_FName